theory stack_theorem
imports Main concur_history_relations remove_relaxed_stack elimination_stack empty_stack

begin

(* Let <A, pre, val> be a history, where A is the set of operations (the universe), pre is the 
   precedence order, and val is the value relation. If <A, pre, val> is linearizable with respect to 
   SET (linearizable_set pre val emp) and order-correct (order_correct pre val), then <A, pre, val> 
   is linearizable with respect to STACK (linearizable_stack pre val emp. The predicate emp 
   indicates pop-empty operations.  *)
theorem thm_stack_theorem : "linearizable_set pre val emp \<Longrightarrow> order_correct pre val \<Longrightarrow>
 linearizable_stack pre val emp"
by (metis (poly_guards_query) concurrent_empty_stack_linearizable elimination_theorem linearizable_set_def linearizable_set_then_wellformed order_correct_then_remove_relaxed_stack pre_conc_history_then_non_empty_pre_conc_history remove_relaxed_stack_linearizable conc_history.abcd)

end
